package me.hammerle.supersnuvi.entity.components.ai;

import me.hammerle.supersnuvi.entity.Entity;
import me.hammerle.supersnuvi.tiles.Location;
import me.hammerle.supersnuvi.tiles.Ramp;
import me.hammerle.supersnuvi.util.Face;

public class StartScreenHeroController extends HumanController
{
    private boolean shouldJump = false;
    
    public StartScreenHeroController(Entity ent) 
    {
        super(ent);
    }
    
    @Override
    public void tick() 
    {
        if(ent.getHealth().isDead())
        {
            ox = ent.getFace() == Face.RIGHT ? 0.0f: -37.0f;
            oy = 0.0f;
            h = 64.0f;
            w = 64.0f;
            
            tx = (deathFrame * 64.0f) / SIZE;
            if(deathFrame < 16)
            {
                ty = 192.0f / SIZE;
            }
            else
            {
                ty = 256.0f / SIZE;
            }
            
            nextDeathFrame();
            return;
        }
        
        ent.setMotionX(ent.getMovement().getVelocityX());
        
        if(shouldJump)
        {
            shouldJump = false;
            ent.getMovement().jump();
        }
        
        ox = ent.getFace() == Face.RIGHT ? 0.0f: -5.0f;
        oy = 0.0f;
        h = 64.0f;
        w = 32.0f;
        
        if(ent.isOnGround())
        {
            if(ent.getMotionX() == 0.0f)
            {
                tx = (idleFrame * 32.0f) / SIZE;
                ty = 128.0f / SIZE;
                nextIdleFrame();
            }
            else
            {               
                tx = (96.0f + walkFrame * 32.0f) / SIZE;
                ty = 0.0f;
                nextWalkFrame();
            }
        }
        else
        {
            resetFrames();
            tx = 0.0f;
            ty = 0.0f;
        }
    }

    @Override
    public void onCollideWithTile(Location loc, Face face)
    {
        if(face == Face.RIGHT && !(loc.getTile() instanceof Ramp))
        {
            shouldJump = true;
        }
    }
}

