package me.hammerle.supersnuvi.gamelogic;

import java.util.List;
import java.util.function.Consumer;
import me.hammerle.snuviscript.code.Script;
import me.hammerle.supersnuvi.entity.Entity;
import me.hammerle.supersnuvi.tiles.Location;
import me.hammerle.supersnuvi.util.CollisionObject;

public interface ILevel
{
    public int getWidth();
    public int getHeight();
    
    public Entity getHero();
    
    public void spawnEntity(Entity ent);
    
    public void scheduleReset();
    public void finishLevel();
    
    public void increaseSouls(int score);
    
    public void updateTile(int layer, int x, int y);
    public void updateTile(int x, int y);
    
    public List<CollisionObject> getMovementBoxesAt(CollisionObject box, Entity not);
    public List<Location> getCollisionBoxesAt(CollisionObject cb);
    public List<Entity> getEntitiesCollidingWith(Entity not, CollisionObject cb);
    
    public void callEvent(String name, Consumer<Script> before, Consumer<Script> after);
    public void callEvent(String name);
}
