package me.hammerle.supersnuvi.snuviscript;

import me.hammerle.snuviscript.code.ISnuviLogger;
import me.hammerle.snuviscript.code.Script;

public class SnuviLogger implements ISnuviLogger
{
    private void printListElement(String name, String content)
    {
        System.out.print(" - ");
        System.out.print(name);
        System.out.print(": ");
        System.out.println(content);
    }
    
    @Override
    public void print(String message, Exception ex, String function, String scriptname, Script sc, int line) 
    {
        if(scriptname != null)
        {
            if(sc != null)
            {
                System.out.println("error in '" + scriptname + "' " + sc.getId());
            }
            else
            {
                System.out.println("error in '" + scriptname + "'");
            }
        }
        if(message != null)
        {
            printListElement("message", message);
        }
        if(ex != null)
        {
            printListElement("exception", ex.getClass().getSimpleName());
            printListElement("exception", ex.getMessage());
        }
        if(function != null)
        {
            printListElement("function", function);
        }
        if(line != -1)
        {
            printListElement("line", String.valueOf(line));
        }
    }
}
