package me.hammerle.supersnuvi.tiles;

import me.hammerle.supersnuvi.Keys;
import me.hammerle.supersnuvi.entity.Entity;
import me.hammerle.supersnuvi.gamelogic.ILevel;
import me.hammerle.supersnuvi.util.CollisionObject;
import me.hammerle.supersnuvi.util.Face;

public class InteractTile extends BaseTile
{
    public InteractTile(float tMinX, float tMinY, float tMaxX, float tMaxY)
    {
        super(tMinX, tMinY, tMaxX, tMaxY);
        super.setCollisionBox(CollisionObject.DEFAULT_TILE_BOX);
        super.setMovementBox(CollisionObject.NULL_BOX);
    }

    @Override
    public boolean shouldAiUseCollisionBox(int x, int y, ILevel l)
    {
        return false;
    }

    @Override
    public void onEntityCollide(Entity ent, int x, int y, Face face, ILevel l)
    {
        if(ent.getItemCollector().isHero() && Keys.UP.getTime() == 1 && face == Face.DOWN)
        {
            l.callEvent("tile_interact", (sc) -> 
            {
                sc.setVar("tile_x", (double) x);
                sc.setVar("tile_y", (double) y);
            }, null);
        }
    }
}
